/*!
* Copyright Adaptavist 2023 (c) All rights reserved
*/
import { getHeaders } from "@managed-api/commons-core";
import { parse } from "json-bigint";
export function constructHeaders(body, manualHeaders) {
    return getHeaders(body, manualHeaders);
}
export function parseResponseWithLongNumbers(response) {
    const data = parse(response);
    const parsedData = JSON.parse(JSON.stringify(data));
    return parsedData;
}
export async function errorMessageBuilder(response, reason) {
    let errorMessage = reason;
    try {
        const error = await response.json();
        if (error.message) {
            errorMessage = `${reason} - ${error.message} Request ID: ${error.requestId}.`;
        }
    }
    catch {
        const text = await response.text();
        errorMessage = `${reason} - ${text}`;
    }
    return errorMessage;
}
//# sourceMappingURL=common.js.map