/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ResponderAsResponse } from "../definitions/ResponderAsResponse";
export interface BaseIncidentAsResponse {
    id: string;
    tinyId?: string;
    message?: string;
    status?: string;
    isSeen?: boolean;
    tags?: Array<string>;
    createdAt?: string;
    updatedAt?: string;
    source?: string;
    owner?: string;
    priority?: string;
    responders?: Array<ResponderAsResponse>;
    ownerTeam?: string;
    /**
     * Map of key-value pairs to use as custom properties of the incident
     */
    extraProperties?: {
        [x: string]: string;
    };
    impactStartDate?: string;
    impactDetectDate?: string;
    impactEndDate?: string;
    description?: string;
    impactedServices?: Array<string>;
    links?: {
        [x: string]: string;
    };
    /**
     * Custom actions that will be available for the alert
     */
    actions?: Array<string>;
}
//# sourceMappingURL=BaseIncidentAsResponse.d.ts.map