/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { AlertActionPayload } from "../definitions/AlertActionPayload";
import { Recipient } from "../definitions/Recipient";
import { Responders } from "../definitions/Responders";
export declare type CreateAlertPayload = AlertActionPayload & {
    /**
     * Message of the alert
     */
    message: string;
    /**
     * Client-defined identifier of the alert, that is also the key element of alert deduplication.
     */
    alias?: string;
    /**
     * Description field of the alert that is generally used to provide a detailed information about the alert.
     */
    description?: string;
    /**
     * Responders that the alert will be routed to send notifications
     */
    responders?: Array<Recipient>;
    /**
     * Teams and users that the alert will become visible to without sending any notification
     */
    visibleTo?: Array<Responders>;
    /**
     * Custom actions that will be available for the alert
     */
    actions?: Array<string>;
    /**
     * Tags of the alert
     */
    tags?: Array<string>;
    /**
     * Map of key-value pairs to use as custom properties of the alert
     */
    details?: {
        [x: string]: string;
    };
    /**
     * Entity field of the alert that is generally used to specify which domain alert is related to
     */
    entity?: string;
    /**
     * Priority level of the alert
     */
    priority?: "P1" | "P2" | "P3" | "P4" | "P5";
};
//# sourceMappingURL=CreateAlertPayload.d.ts.map