/*!
* Copyright Adaptavist 2023 (c) All rights reserved
*/
import { HttpError, BaseErrorStrategyHandlers, BaseErrorStrategyOption, CustomErrorHandler, ErrorStrategyBuilderConstructor } from "@managed-api/commons-core";
import { ErrorStrategyBuilder } from "./builders/errorStrategy";
export interface CommonError {
    message?: string;
    requestId?: string;
}
export declare type AdditionalErrorTypes = HttpError<CommonError>;
export interface ErrorStrategyHandlers extends BaseErrorStrategyHandlers<CommonError, AdditionalErrorTypes> {
}
export interface ErrorStrategyOption extends BaseErrorStrategyOption<CommonError, AdditionalErrorTypes, ErrorStrategyHandlers, ErrorStrategyBuilder> {
}
export declare const customErrorHandlers: CustomErrorHandler[];
export declare const errorStrategyBuilderConstructor: ErrorStrategyBuilderConstructor<CommonError, AdditionalErrorTypes, ErrorStrategyHandlers, ErrorStrategyBuilder>;
//# sourceMappingURL=errorStrategy.d.ts.map