/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { AddNoteToAlertRequest, AddNoteToAlertResponseOK } from "./types/alert/note";
import { GetAlertNotesRequest, GetAlertNotesResponseOK } from "./types/alert/note";
import { AddTagsToAlertRequest, AddTagsToAlertResponseOK } from "./types/alert/tags";
import { RemoveTagsFromAlertRequest, RemoveTagsFromAlertResponseOK } from "./types/alert/tags";
import { AddDetailsToAlertRequest, AddDetailsToAlertResponseOK } from "./types/alert/details";
import { RemoveDetailsFromAlertRequest, RemoveDetailsFromAlertResponseOK } from "./types/alert/details";
import { CreateSavedSearchForAlertRequest, CreateSavedSearchForAlertResponseOK } from "./types/alert/saved/search";
import { GetSavedSearchesForAlertRequest, GetSavedSearchesForAlertResponseOK } from "./types/alert/saved/search";
import { UpdateSavedSearchForAlertRequest, UpdateSavedSearchForAlertResponseOK } from "./types/alert/saved/search";
import { GetSavedSearchForAlertRequest, GetSavedSearchForAlertResponseOK } from "./types/alert/saved/search";
import { DeleteSavedSearchForAlertRequest, DeleteSavedSearchForAlertResponseOK } from "./types/alert/saved/search";
import { GetAlertAttachmentsRequest, GetAlertAttachmentsResponseOK } from "./types/alert/attachment";
import { CreateAlertAttachmentRequest, CreateAlertAttachmentResponseOK } from "./types/alert/attachment";
import { GetAlertAttachmentRequest, GetAlertAttachmentResponseOK } from "./types/alert/attachment";
import { DeleteAlertAttachmentRequest, DeleteAlertAttachmentResponseOK } from "./types/alert/attachment";
import { GetRequestStatusforAlertRequest, GetRequestStatusforAlertResponseOK } from "./types/alert";
import { GetAlertRequest, GetAlertResponseOK } from "./types/alert";
import { DeleteAlertRequest, DeleteAlertResponseOK } from "./types/alert";
import { GetAlertsRequest, GetAlertsResponseOK } from "./types/alert";
import { CreateAlertRequest, CreateAlertResponseOK } from "./types/alert";
import { CountAlertsRequest, CountAlertsResponseOK } from "./types/alert";
import { AcknowledgeAlertRequest, AcknowledgeAlertResponseOK } from "./types/alert";
import { CloseAlertRequest, CloseAlertResponseOK } from "./types/alert";
import { ExecuteCustomAlertActionRequest, ExecuteCustomAlertActionResponseOK } from "./types/alert";
import { UnacknowledgeAlertRequest, UnacknowledgeAlertResponseOK } from "./types/alert";
import { SnoozeAlertRequest, SnoozeAlertResponseOK } from "./types/alert";
import { EscalateAlertToNextRequest, EscalateAlertToNextResponseOK } from "./types/alert";
import { AssignAlertRequest, AssignAlertResponseOK } from "./types/alert";
import { AddTeamToAlertRequest, AddTeamToAlertResponseOK } from "./types/alert";
import { AddResponderToAlertRequest, AddResponderToAlertResponseOK } from "./types/alert";
import { UpdateAlertPriorityRequest, UpdateAlertPriorityResponseOK } from "./types/alert";
import { UpdateAlertMessageRequest, UpdateAlertMessageResponseOK } from "./types/alert";
import { UpdateAlertDescriptionRequest, UpdateAlertDescriptionResponseOK } from "./types/alert";
import { GetAlertRecipientsRequest, GetAlertRecipientsResponseOK } from "./types/alert";
import { GetAlertLogsRequest, GetAlertLogsResponseOK } from "./types/alert";
import { GetAssociatedAlertsForIncidentRequest, GetAssociatedAlertsForIncidentResponseOK } from "./types/incident/alert";
import { GetResponderAlertsForIncidentRequest, GetResponderAlertsForIncidentResponseOK } from "./types/incident/alert";
import { AddNoteToIncidentRequest, AddNoteToIncidentResponseOK } from "./types/incident/note";
import { GetIncidentNotesRequest, GetIncidentNotesResponseOK } from "./types/incident/note";
import { AddTagsToIncidentRequest, AddTagsToIncidentResponseOK } from "./types/incident/tags";
import { RemoveTagsFromIncidentRequest, RemoveTagsFromIncidentResponseOK } from "./types/incident/tags";
import { AddDetailsToIncidentRequest, AddDetailsToIncidentResponseOK } from "./types/incident/details";
import { RemoveDetailsFromIncidentRequest, RemoveDetailsFromIncidentResponseOK } from "./types/incident/details";
import { AddIncidentTimelineEntryRequest, AddIncidentTimelineEntryResponseOK } from "./types/incident/timeline";
import { GetIncidentTimelineEntriesRequest, GetIncidentTimelineEntriesResponseOK } from "./types/incident/timeline";
import { GetIncidentTimelineEntryRequest, GetIncidentTimelineEntryResponseOK } from "./types/incident/timeline";
import { UpdateIncidentTimelineEntryRequest, UpdateIncidentTimelineEntryResponseOK } from "./types/incident/timeline";
import { DeleteIncidentTimelineEntryRequest, DeleteIncidentTimelineEntryResponseOK } from "./types/incident/timeline";
import { HideIncidentTimelineEntryRequest, HideIncidentTimelineEntryResponseOK } from "./types/incident/timeline";
import { UnhideIncidentTimelineEntryRequest, UnhideIncidentTimelineEntryResponseOK } from "./types/incident/timeline";
import { GetRequestStatusForIncidentRequest, GetRequestStatusForIncidentResponseOK } from "./types/incident";
import { CreateIncidentRequest, CreateIncidentResponseOK } from "./types/incident";
import { DeleteIncidentRequest, DeleteIncidentResponseOK } from "./types/incident";
import { GetIncidentRequest, GetIncidentResponseOK } from "./types/incident";
import { GetIncidentsRequest, GetIncidentsResponseOK } from "./types/incident";
import { CloseIncidentRequest, CloseIncidentResponseOK } from "./types/incident";
import { ResolveIncidentRequest, ResolveIncidentResponseOK } from "./types/incident";
import { ReopenIncidentRequest, ReopenIncidentResponseOK } from "./types/incident";
import { AddResponderToIncidentRequest, AddResponderToIncidentResponseOK } from "./types/incident";
import { UpdateIncidentPriorityRequest, UpdateIncidentPriorityResponseOK } from "./types/incident";
import { UpdateIncidentMessageRequest, UpdateIncidentMessageResponseOK } from "./types/incident";
import { UpdateIncidentDescriptionRequest, UpdateIncidentDescriptionResponseOK } from "./types/incident";
import { GetIncidentLogsRequest, GetIncidentLogsResponseOK } from "./types/incident";
import { BaseApiCore, Headers, Response, ErrorStrategyOptionType, PlatformImplementation } from "@managed-api/commons-core";
import { CommonError, AdditionalErrorTypes, ErrorStrategyHandlers, ErrorStrategyOption } from "./errorStrategy";
import { ErrorStrategyBuilder } from "./builders/errorStrategy";
export interface OpsgenieApiCoreOptions extends ErrorStrategyOption {
}
declare type GetGlobalErrorStrategy = () => ErrorStrategyOptionType<CommonError, AdditionalErrorTypes, ErrorStrategyHandlers, ErrorStrategyBuilder> | undefined;
export declare abstract class OpsgenieApiCore extends BaseApiCore {
    private options?;
    Alert: AlertGroup;
    Incident: IncidentGroup;
    All: AllGroup;
    constructor(options?: OpsgenieApiCoreOptions | undefined);
    setGlobalErrorStrategy(errorStrategy: ErrorStrategyOptionType<CommonError, AdditionalErrorTypes, ErrorStrategyHandlers, ErrorStrategyBuilder>): void;
    protected buildResponse(url: string, status: number, statusText: string, headers: Headers, body?: string | ArrayBuffer): Response<any>;
    private getGlobalErrorStrategy;
}
declare class AllGroup {
    private Alert;
    private Incident;
    constructor(Alert: AlertGroup, Incident: IncidentGroup);
    /**
     * Used to track the status and alert details (if any) of the request whose identifier is given
     * Alternative usage: Alert.getRequestStatus
     * Documentation: https://docs.opsgenie.com/docs/alert-api#get-request-status
     * @param options Request options.
     */
    getRequestStatusforAlert<T = GetRequestStatusforAlertResponseOK>(options: GetRequestStatusforAlertRequest): Promise<GetRequestStatusforAlertResponseOK | T>;
    /**
     * Returns alert with given id, tiny id or alias
     * Alternative usage: Alert.getAlert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#get-alert
     * @param options Request options.
     */
    getAlert<T = GetAlertResponseOK>(options: GetAlertRequest): Promise<GetAlertResponseOK | T>;
    /**
     * Deletes an alert using alert id, tiny id or alias
     * Alternative usage: Alert.deleteAlert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#delete-alert
     * @param options Request options.
     */
    deleteAlert<T = DeleteAlertResponseOK>(options: DeleteAlertRequest): Promise<DeleteAlertResponseOK | T>;
    /**
     * Returns list of alerts
     * Alternative usage: Alert.getAlerts
     * Documentation: https://docs.opsgenie.com/docs/alert-api#list-alerts
     * @param options Request options.
     */
    getAlerts<T = GetAlertsResponseOK>(options?: GetAlertsRequest): Promise<GetAlertsResponseOK | T>;
    /**
     * Creates a new alert
     * Alternative usage: Alert.createAlert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#create-alert
     * @param options Request options.
     */
    createAlert<T = CreateAlertResponseOK>(options: CreateAlertRequest): Promise<CreateAlertResponseOK | T>;
    /**
     * Count alerts in Opsgenie
     * Alternative usage: Alert.countAlerts
     * Documentation: https://docs.opsgenie.com/docs/alert-api#count-alerts
     * @param options Request options.
     */
    countAlerts<T = CountAlertsResponseOK>(options?: CountAlertsRequest): Promise<CountAlertsResponseOK | T>;
    /**
     * Acknowledges alert with given identifier
     * Alternative usage: Alert.acknowledgeAlert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#acknowledge-alert
     * @param options Request options.
     */
    acknowledgeAlert<T = AcknowledgeAlertResponseOK>(options: AcknowledgeAlertRequest): Promise<AcknowledgeAlertResponseOK | T>;
    /**
     * Closes alert with given identifier
     * Alternative usage: Alert.closeAlert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#close-alert
     * @param options Request options.
     */
    closeAlert<T = CloseAlertResponseOK>(options: CloseAlertRequest): Promise<CloseAlertResponseOK | T>;
    /**
     * Custom actions for the alert
     * Alternative usage: Alert.executeCustomAction
     * Documentation: https://docs.opsgenie.com/docs/alert-api#execute-custom-action
     * @param options Request options.
     */
    executeCustomAlertAction<T = ExecuteCustomAlertActionResponseOK>(options: ExecuteCustomAlertActionRequest): Promise<ExecuteCustomAlertActionResponseOK | T>;
    /**
     * UnAcknowledge alert with given identifier
     * Alternative usage: Alert.unacknowledgeAlert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#unacknowledge-alert
     * @param options Request options.
     */
    unacknowledgeAlert<T = UnacknowledgeAlertResponseOK>(options: UnacknowledgeAlertRequest): Promise<UnacknowledgeAlertResponseOK | T>;
    /**
     * Snooze alert with given identifier
     * Alternative usage: Alert.snoozeAlert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#snooze-alert
     * @param options Request options.
     */
    snoozeAlert<T = SnoozeAlertResponseOK>(options: SnoozeAlertRequest): Promise<SnoozeAlertResponseOK | T>;
    /**
     * Escalate alert with given identifier
     * Alternative usage: Alert.escalateAlertToNext
     * Documentation: https://docs.opsgenie.com/docs/alert-api#escalate-alert-to-next
     * @param options Request options.
     */
    escalateAlertToNext<T = EscalateAlertToNextResponseOK>(options: EscalateAlertToNextRequest): Promise<EscalateAlertToNextResponseOK | T>;
    /**
     * Assign alert with given identifier
     * Alternative usage: Alert.assignAlert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#assign-alert
     * @param options Request options.
     */
    assignAlert<T = AssignAlertResponseOK>(options: AssignAlertRequest): Promise<AssignAlertResponseOK | T>;
    /**
     * Add team to alert with given identifier
     * Alternative usage: Alert.addTeam
     * Documentation: https://docs.opsgenie.com/docs/alert-api#add-team-to-alert
     * @param options Request options.
     */
    addTeamToAlert<T = AddTeamToAlertResponseOK>(options: AddTeamToAlertRequest): Promise<AddTeamToAlertResponseOK | T>;
    /**
     * Add responder to alert with given identifier
     * Alternative usage: Alert.addResponder
     * Documentation: https://docs.opsgenie.com/docs/alert-api#add-responder-to-alert
     * @param options Request options.
     */
    addResponderToAlert<T = AddResponderToAlertResponseOK>(options: AddResponderToAlertRequest): Promise<AddResponderToAlertResponseOK | T>;
    /**
     * Update the priority of the alert with given identifier
     * Alternative usage: Alert.updatePriority
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#update-alert-priority
     * @param options Request options.
     */
    updateAlertPriority<T = UpdateAlertPriorityResponseOK>(options: UpdateAlertPriorityRequest): Promise<UpdateAlertPriorityResponseOK | T>;
    /**
     * Update the message of the alert with given identifier
     * Alternative usage: Alert.updateMessage
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#update-alert-message
     * @param options Request options.
     */
    updateAlertMessage<T = UpdateAlertMessageResponseOK>(options: UpdateAlertMessageRequest): Promise<UpdateAlertMessageResponseOK | T>;
    /**
     * Update the description of the alert with given identifier
     * Alternative usage: Alert.updateDescription
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#update-alert-description
     * @param options Request options.
     */
    updateAlertDescription<T = UpdateAlertDescriptionResponseOK>(options: UpdateAlertDescriptionRequest): Promise<UpdateAlertDescriptionResponseOK | T>;
    /**
     * List alert recipients for the given alert identifier
     * Alternative usage: Alert.getRecipients
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-alert-recipients
     * @param options Request options.
     */
    getAlertRecipients<T = GetAlertRecipientsResponseOK>(options: GetAlertRecipientsRequest): Promise<GetAlertRecipientsResponseOK | T>;
    /**
     * List alert logs for the given alert identifier
     * Alternative usage: Alert.getLogs
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-alert-logs
     * @param options Request options.
     */
    getAlertLogs<T = GetAlertLogsResponseOK>(options: GetAlertLogsRequest): Promise<GetAlertLogsResponseOK | T>;
    /**
     * Adds note to alert with given identifier
     * Alternative usage: Alert.Note.addNote
     * Documentation: https://docs.opsgenie.com/docs/alert-api#add-note-to-alert
     * @param options Request options.
     */
    addNoteToAlert<T = AddNoteToAlertResponseOK>(options: AddNoteToAlertRequest): Promise<AddNoteToAlertResponseOK | T>;
    /**
     * List alert notes for the given alert identifier
     * Alternative usage: Alert.Note.getNotes
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-alert-notes
     * @param options Request options.
     */
    getAlertNotes<T = GetAlertNotesResponseOK>(options: GetAlertNotesRequest): Promise<GetAlertNotesResponseOK | T>;
    /**
     * Add tags to the alert with given identifier
     * Alternative usage: Alert.Tags.addTags
     * Documentation: https://docs.opsgenie.com/docs/alert-api#add-tags-to-alert
     * @param options Request options.
     */
    addTagsToAlert<T = AddTagsToAlertResponseOK>(options: AddTagsToAlertRequest): Promise<AddTagsToAlertResponseOK | T>;
    /**
     * Remove tags of the alert with given identifier
     * Alternative usage: Alert.Tags.removeTags
     * Documentation: https://docs.opsgenie.com/docs/alert-api#remove-tags-from-alert
     * @param options Request options.
     */
    removeTagsFromAlert<T = RemoveTagsFromAlertResponseOK>(options: RemoveTagsFromAlertRequest): Promise<RemoveTagsFromAlertResponseOK | T>;
    /**
     * Add details to the alert with given identifier
     * Alternative usage: Alert.Details.addDetails
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#add-details-custom-properties-to-alert
     * @param options Request options.
     */
    addDetailsToAlert<T = AddDetailsToAlertResponseOK>(options: AddDetailsToAlertRequest): Promise<AddDetailsToAlertResponseOK | T>;
    /**
     * Remove details of the alert with given identifier
     * Alternative usage: Alert.Details.removeDetails
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#remove-details-custom-properties-from-alert
     * @param options Request options.
     */
    removeDetailsFromAlert<T = RemoveDetailsFromAlertResponseOK>(options: RemoveDetailsFromAlertRequest): Promise<RemoveDetailsFromAlertResponseOK | T>;
    /**
     * Create saved search with given fields
     * Alternative usage: Alert.Saved.Search.createSavedSearch
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#create-a-saved-search
     * @param options Request options.
     */
    createSavedSearchForAlert<T = CreateSavedSearchForAlertResponseOK>(options: CreateSavedSearchForAlertRequest): Promise<CreateSavedSearchForAlertResponseOK | T>;
    /**
     * List all saved searches
     * Alternative usage: Alert.Saved.Search.getSavedSearches
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-saved-searches
     * @param options Request options.
     */
    getSavedSearchesForAlert<T = GetSavedSearchesForAlertResponseOK>(options?: GetSavedSearchesForAlertRequest): Promise<GetSavedSearchesForAlertResponseOK | T>;
    /**
     * Update saved search for the given search identifier
     * Alternative usage: Alert.Saved.Search.updateSavedSearch
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#update-saved-search
     * @param options Request options.
     */
    updateSavedSearchForAlert<T = UpdateSavedSearchForAlertResponseOK>(options: UpdateSavedSearchForAlertRequest): Promise<UpdateSavedSearchForAlertResponseOK | T>;
    /**
     * Get saved search for the given search identifier
     * Alternative usage: Alert.Saved.Search.getSavedSearch
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#get-saved-search
     * @param options Request options.
     */
    getSavedSearchForAlert<T = GetSavedSearchForAlertResponseOK>(options: GetSavedSearchForAlertRequest): Promise<GetSavedSearchForAlertResponseOK | T>;
    /**
     * Deletes saved search using given search identifier
     * Alternative usage: Alert.Saved.Search.deleteSavedSearch
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#delete-saved-search
     * @param options Request options.
     */
    deleteSavedSearchForAlert<T = DeleteSavedSearchForAlertResponseOK>(options: DeleteSavedSearchForAlertRequest): Promise<DeleteSavedSearchForAlertResponseOK | T>;
    /**
     * List alert attachment names and urls for related alert
     * Alternative usage: Alert.Attachment.getAttachments
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-alert-attachments
     * @param options Request options.
     */
    getAlertAttachments<T = GetAlertAttachmentsResponseOK>(options: GetAlertAttachmentsRequest): Promise<GetAlertAttachmentsResponseOK | T>;
    /**
     * Add Alert Attachment to related alert
     * Alternative usage: Alert.Attachment.createAttachment
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#create-alert-attachment
     * @param options Request options.
     */
    createAlertAttachment<T = CreateAlertAttachmentResponseOK>(options: CreateAlertAttachmentRequest): Promise<CreateAlertAttachmentResponseOK | T>;
    /**
     * Get alert attachment name and url for the given identifier
     * Alternative usage: Alert.Attachment.getAttachment
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#get-alert-attachment
     * @param options Request options.
     */
    getAlertAttachment<T = GetAlertAttachmentResponseOK>(options: GetAlertAttachmentRequest): Promise<GetAlertAttachmentResponseOK | T>;
    /**
     * Remove alert attachment for the given identifier
     * Alternative usage: Alert.Attachment.deleteAttachment
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#delete-alert-attachment
     * @param options Request options.
     */
    deleteAlertAttachment<T = DeleteAlertAttachmentResponseOK>(options: DeleteAlertAttachmentRequest): Promise<DeleteAlertAttachmentResponseOK | T>;
    /**
     * Used to track the status and incident details (if any) of the request whose identifier is given
     * Alternative usage: Incident.getRequestStatus
     * Documentation: https://docs.opsgenie.com/docs/incident-api#get-request-status
     * @param options Request options.
     */
    getRequestStatusForIncident<T = GetRequestStatusForIncidentResponseOK>(options: GetRequestStatusForIncidentRequest): Promise<GetRequestStatusForIncidentResponseOK | T>;
    /**
     * Creates a new incident
     * Alternative usage: Incident.createIncident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#create-incident
     * @param options Request options.
     */
    createIncident<T = CreateIncidentResponseOK>(options: CreateIncidentRequest): Promise<CreateIncidentResponseOK | T>;
    /**
     * Deletes an incident using incident id or the tiny id
     * Alternative usage: Incident.deleteIncident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#delete-incident
     * @param options Request options.
     */
    deleteIncident<T = DeleteIncidentResponseOK>(options: DeleteIncidentRequest): Promise<DeleteIncidentResponseOK | T>;
    /**
     * Returns incident with given id, tiny id or alias
     * Alternative usage: Incident.getIncident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#get-incident
     * @param options Request options.
     */
    getIncident<T = GetIncidentResponseOK>(options: GetIncidentRequest): Promise<GetIncidentResponseOK | T>;
    /**
     * Return list of incidents
     * Alternative usage: Incident.getIncidents
     * Documentation: https://docs.opsgenie.com/docs/incident-api#list-incidents
     * @param options Request options.
     */
    getIncidents<T = GetIncidentsResponseOK>(options?: GetIncidentsRequest): Promise<GetIncidentsResponseOK | T>;
    /**
     * Closes incident with given identifier
     * Alternative usage: Incident.closeIncident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#close-incident
     * @param options Request options.
     */
    closeIncident<T = CloseIncidentResponseOK>(options: CloseIncidentRequest): Promise<CloseIncidentResponseOK | T>;
    /**
     * Resolves incident
     * Alternative usage: Incident.resolveIncident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#resolve-incident
     * @param options Request options.
     */
    resolveIncident<T = ResolveIncidentResponseOK>(options: ResolveIncidentRequest): Promise<ResolveIncidentResponseOK | T>;
    /**
     * Reopenss incident
     * Alternative usage: Incident.reopenIncident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#reopen-incident
     * @param options Request options.
     */
    reopenIncident<T = ReopenIncidentResponseOK>(options: ReopenIncidentRequest): Promise<ReopenIncidentResponseOK | T>;
    /**
     * Add responder to incident with given identifier
     * Alternative usage: Incident.addResponder
     * Documentation: https://docs.opsgenie.com/docs/incident-api#add-responder-to-incident
     * @param options Request options.
     */
    addResponderToIncident<T = AddResponderToIncidentResponseOK>(options: AddResponderToIncidentRequest): Promise<AddResponderToIncidentResponseOK | T>;
    /**
     * Update the priority of the incident with given identifier
     * Alternative usage: Incident.updatePriority
     * Documentation: https://docs.opsgenie.com/docs/incident-api#update-incident-priority
     * @param options Request options.
     */
    updateIncidentPriority<T = UpdateIncidentPriorityResponseOK>(options: UpdateIncidentPriorityRequest): Promise<UpdateIncidentPriorityResponseOK | T>;
    /**
     * Update the Message of the incident with given identifier
     * Alternative usage: Incident.updateMessage
     * Documentation: https://docs.opsgenie.com/docs/incident-api#update-incident-message
     * @param options Request options.
     */
    updateIncidentMessage<T = UpdateIncidentMessageResponseOK>(options: UpdateIncidentMessageRequest): Promise<UpdateIncidentMessageResponseOK | T>;
    /**
     * Update the Description of the incident with given identifier
     * Alternative usage: Incident.updateDescription
     * Documentation: https://docs.opsgenie.com/docs/incident-api#update-incident-description
     * @param options Request options.
     */
    updateIncidentDescription<T = UpdateIncidentDescriptionResponseOK>(options: UpdateIncidentDescriptionRequest): Promise<UpdateIncidentDescriptionResponseOK | T>;
    /**
     * List incident logs for the given incident identifier
     * Alternative usage: Incident.getLogs
     * Documentation: https://docs.opsgenie.com/docs/incident-api#list-incident-logs
     * @param options Request options.
     */
    getIncidentLogs<T = GetIncidentLogsResponseOK>(options: GetIncidentLogsRequest): Promise<GetIncidentLogsResponseOK | T>;
    /**
     * Returns associated alerts for incident
     * Alternative usage: Incident.Alert.getAssociatedAlerts
     * Documentation: https://docs.opsgenie.com/docs/incident-api#get-associated-alerts
     * @param options Request options.
     */
    getAssociatedAlertsForIncident<T = GetAssociatedAlertsForIncidentResponseOK>(options: GetAssociatedAlertsForIncidentRequest): Promise<GetAssociatedAlertsForIncidentResponseOK | T>;
    /**
     * Returns responder alerts for incident
     * Alternative usage: Incident.Alert.getResponderAlerts
     * Documentation: https://docs.opsgenie.com/docs/incident-api#get-responder-alerts
     * @param options Request options.
     */
    getResponderAlertsForIncident<T = GetResponderAlertsForIncidentResponseOK>(options: GetResponderAlertsForIncidentRequest): Promise<GetResponderAlertsForIncidentResponseOK | T>;
    /**
     * Adds note to incident with given identifier
     * Alternative usage: Incident.Note.addNote
     * Documentation: https://docs.opsgenie.com/docs/incident-api#add-note-to-incident
     * @param options Request options.
     */
    addNoteToIncident<T = AddNoteToIncidentResponseOK>(options: AddNoteToIncidentRequest): Promise<AddNoteToIncidentResponseOK | T>;
    /**
     * List incident notes for the given alert identifier
     * Alternative usage: Incident.Note.getNotes
     * Documentation: https://docs.opsgenie.com/docs/incident-api#list-incident-notes
     * @param options Request options.
     */
    getIncidentNotes<T = GetIncidentNotesResponseOK>(options: GetIncidentNotesRequest): Promise<GetIncidentNotesResponseOK | T>;
    /**
     * Add tags to incident with given identifier
     * Alternative usage: Incident.Tags.addTags
     * Documentation: https://docs.opsgenie.com/docs/incident-api#add-tags-to-incident
     * @param options Request options.
     */
    addTagsToIncident<T = AddTagsToIncidentResponseOK>(options: AddTagsToIncidentRequest): Promise<AddTagsToIncidentResponseOK | T>;
    /**
     * Remove tags from incident with given identifier
     * Alternative usage: Incident.Tags.removeTags
     * Documentation: https://docs.opsgenie.com/docs/incident-api#remove-tags-from-incident
     * @param options Request options.
     */
    removeTagsFromIncident<T = RemoveTagsFromIncidentResponseOK>(options: RemoveTagsFromIncidentRequest): Promise<RemoveTagsFromIncidentResponseOK | T>;
    /**
     * Add Details(Custom Properties) to Incident
     * Alternative usage: Incident.Details.addDetails
     * Documentation: https://docs.opsgenie.com/docs/incident-api#add-detailscustom-properties-to-incident
     * @param options Request options.
     */
    addDetailsToIncident<T = AddDetailsToIncidentResponseOK>(options: AddDetailsToIncidentRequest): Promise<AddDetailsToIncidentResponseOK | T>;
    /**
     * Remove details from Incident
     * Alternative usage: Incident.Details.removeDetails
     * Documentation: https://docs.opsgenie.com/docs/incident-api#remove-detailscustom-properties-from-incident
     * @param options Request options.
     */
    removeDetailsFromIncident<T = RemoveDetailsFromIncidentResponseOK>(options: RemoveDetailsFromIncidentRequest): Promise<RemoveDetailsFromIncidentResponseOK | T>;
    /**
     * Add Incident Timeline Entry to incident with the incident Id
     * Alternative usage: Incident.Timeline.addEntry
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#add-incident-timeline-entry
     * @param options Request options.
     */
    addIncidentTimelineEntry<T = AddIncidentTimelineEntryResponseOK>(options: AddIncidentTimelineEntryRequest): Promise<AddIncidentTimelineEntryResponseOK | T>;
    /**
     * List incident timeline entries for the given incident Id
     * Alternative usage: Incident.Timeline.getEntries
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#list-incident-timeline-entries
     * @param options Request options.
     */
    getIncidentTimelineEntries<T = GetIncidentTimelineEntriesResponseOK>(options: GetIncidentTimelineEntriesRequest): Promise<GetIncidentTimelineEntriesResponseOK | T>;
    /**
     * Get incident timeline entry for the given identifier
     * Alternative usage: Incident.Timeline.getEntry
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#get-incident-timeline-entry
     * @param options Request options.
     */
    getIncidentTimelineEntry<T = GetIncidentTimelineEntryResponseOK>(options: GetIncidentTimelineEntryRequest): Promise<GetIncidentTimelineEntryResponseOK | T>;
    /**
     * Updates incident timeline entry for the given identifier
     * Alternative usage: Incident.Timeline.updateEntry
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#update-incident-timeline-entry
     * @param options Request options.
     */
    updateIncidentTimelineEntry<T = UpdateIncidentTimelineEntryResponseOK>(options: UpdateIncidentTimelineEntryRequest): Promise<UpdateIncidentTimelineEntryResponseOK | T>;
    /**
     * Deletes incident timeline entry for the given identifier
     * Alternative usage: Incident.Timeline.deleteEntry
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#delete-incident-timeline-entry
     * @param options Request options.
     */
    deleteIncidentTimelineEntry<T = DeleteIncidentTimelineEntryResponseOK>(options: DeleteIncidentTimelineEntryRequest): Promise<DeleteIncidentTimelineEntryResponseOK | T>;
    /**
     * Hides incident timeline entry for the given identifier
     * Alternative usage: Incident.Timeline.hideEntry
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#hide-incident-timeline-entry
     * @param options Request options.
     */
    hideIncidentTimelineEntry<T = HideIncidentTimelineEntryResponseOK>(options: HideIncidentTimelineEntryRequest): Promise<HideIncidentTimelineEntryResponseOK | T>;
    /**
     * Unhides incident timeline entry for the given identifier
     * Alternative usage: Incident.Timeline.unhideEntry
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#unhide-incident-timeline-entry
     * @param options Request options.
     */
    unhideIncidentTimelineEntry<T = UnhideIncidentTimelineEntryResponseOK>(options: UnhideIncidentTimelineEntryRequest): Promise<UnhideIncidentTimelineEntryResponseOK | T>;
}
declare class AlertGroup {
    private implementation;
    private getGlobalErrorStrategy;
    Note: AlertNoteGroup;
    Tags: AlertTagsGroup;
    Details: AlertDetailsGroup;
    Saved: AlertSavedGroup;
    Attachment: AlertAttachmentGroup;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Used to track the status and alert details (if any) of the request whose identifier is given
     * Documentation: https://docs.opsgenie.com/docs/alert-api#get-request-status
     * @param options Request options.
     */
    getRequestStatus<T = GetRequestStatusforAlertResponseOK>(options: GetRequestStatusforAlertRequest): Promise<GetRequestStatusforAlertResponseOK | T>;
    /**
     * Returns alert with given id, tiny id or alias
     * Documentation: https://docs.opsgenie.com/docs/alert-api#get-alert
     * @param options Request options.
     */
    getAlert<T = GetAlertResponseOK>(options: GetAlertRequest): Promise<GetAlertResponseOK | T>;
    /**
     * Deletes an alert using alert id, tiny id or alias
     * Documentation: https://docs.opsgenie.com/docs/alert-api#delete-alert
     * @param options Request options.
     */
    deleteAlert<T = DeleteAlertResponseOK>(options: DeleteAlertRequest): Promise<DeleteAlertResponseOK | T>;
    /**
     * Returns list of alerts
     * Documentation: https://docs.opsgenie.com/docs/alert-api#list-alerts
     * @param options Request options.
     */
    getAlerts<T = GetAlertsResponseOK>(options?: GetAlertsRequest): Promise<GetAlertsResponseOK | T>;
    /**
     * Creates a new alert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#create-alert
     * @param options Request options.
     */
    createAlert<T = CreateAlertResponseOK>(options: CreateAlertRequest): Promise<CreateAlertResponseOK | T>;
    /**
     * Count alerts in Opsgenie
     * Documentation: https://docs.opsgenie.com/docs/alert-api#count-alerts
     * @param options Request options.
     */
    countAlerts<T = CountAlertsResponseOK>(options?: CountAlertsRequest): Promise<CountAlertsResponseOK | T>;
    /**
     * Acknowledges alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#acknowledge-alert
     * @param options Request options.
     */
    acknowledgeAlert<T = AcknowledgeAlertResponseOK>(options: AcknowledgeAlertRequest): Promise<AcknowledgeAlertResponseOK | T>;
    /**
     * Closes alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#close-alert
     * @param options Request options.
     */
    closeAlert<T = CloseAlertResponseOK>(options: CloseAlertRequest): Promise<CloseAlertResponseOK | T>;
    /**
     * Custom actions for the alert
     * Documentation: https://docs.opsgenie.com/docs/alert-api#execute-custom-action
     * @param options Request options.
     */
    executeCustomAction<T = ExecuteCustomAlertActionResponseOK>(options: ExecuteCustomAlertActionRequest): Promise<ExecuteCustomAlertActionResponseOK | T>;
    /**
     * UnAcknowledge alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#unacknowledge-alert
     * @param options Request options.
     */
    unacknowledgeAlert<T = UnacknowledgeAlertResponseOK>(options: UnacknowledgeAlertRequest): Promise<UnacknowledgeAlertResponseOK | T>;
    /**
     * Snooze alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#snooze-alert
     * @param options Request options.
     */
    snoozeAlert<T = SnoozeAlertResponseOK>(options: SnoozeAlertRequest): Promise<SnoozeAlertResponseOK | T>;
    /**
     * Escalate alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#escalate-alert-to-next
     * @param options Request options.
     */
    escalateAlertToNext<T = EscalateAlertToNextResponseOK>(options: EscalateAlertToNextRequest): Promise<EscalateAlertToNextResponseOK | T>;
    /**
     * Assign alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#assign-alert
     * @param options Request options.
     */
    assignAlert<T = AssignAlertResponseOK>(options: AssignAlertRequest): Promise<AssignAlertResponseOK | T>;
    /**
     * Add team to alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#add-team-to-alert
     * @param options Request options.
     */
    addTeam<T = AddTeamToAlertResponseOK>(options: AddTeamToAlertRequest): Promise<AddTeamToAlertResponseOK | T>;
    /**
     * Add responder to alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#add-responder-to-alert
     * @param options Request options.
     */
    addResponder<T = AddResponderToAlertResponseOK>(options: AddResponderToAlertRequest): Promise<AddResponderToAlertResponseOK | T>;
    /**
     * Update the priority of the alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#update-alert-priority
     * @param options Request options.
     */
    updatePriority<T = UpdateAlertPriorityResponseOK>(options: UpdateAlertPriorityRequest): Promise<UpdateAlertPriorityResponseOK | T>;
    /**
     * Update the message of the alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#update-alert-message
     * @param options Request options.
     */
    updateMessage<T = UpdateAlertMessageResponseOK>(options: UpdateAlertMessageRequest): Promise<UpdateAlertMessageResponseOK | T>;
    /**
     * Update the description of the alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#update-alert-description
     * @param options Request options.
     */
    updateDescription<T = UpdateAlertDescriptionResponseOK>(options: UpdateAlertDescriptionRequest): Promise<UpdateAlertDescriptionResponseOK | T>;
    /**
     * List alert recipients for the given alert identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-alert-recipients
     * @param options Request options.
     */
    getRecipients<T = GetAlertRecipientsResponseOK>(options: GetAlertRecipientsRequest): Promise<GetAlertRecipientsResponseOK | T>;
    /**
     * List alert logs for the given alert identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-alert-logs
     * @param options Request options.
     */
    getLogs<T = GetAlertLogsResponseOK>(options: GetAlertLogsRequest): Promise<GetAlertLogsResponseOK | T>;
}
declare class AlertNoteGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Adds note to alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#add-note-to-alert
     * @param options Request options.
     */
    addNote<T = AddNoteToAlertResponseOK>(options: AddNoteToAlertRequest): Promise<AddNoteToAlertResponseOK | T>;
    /**
     * List alert notes for the given alert identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-alert-notes
     * @param options Request options.
     */
    getNotes<T = GetAlertNotesResponseOK>(options: GetAlertNotesRequest): Promise<GetAlertNotesResponseOK | T>;
}
declare class AlertTagsGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Add tags to the alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#add-tags-to-alert
     * @param options Request options.
     */
    addTags<T = AddTagsToAlertResponseOK>(options: AddTagsToAlertRequest): Promise<AddTagsToAlertResponseOK | T>;
    /**
     * Remove tags of the alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api#remove-tags-from-alert
     * @param options Request options.
     */
    removeTags<T = RemoveTagsFromAlertResponseOK>(options: RemoveTagsFromAlertRequest): Promise<RemoveTagsFromAlertResponseOK | T>;
}
declare class AlertDetailsGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Add details to the alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#add-details-custom-properties-to-alert
     * @param options Request options.
     */
    addDetails<T = AddDetailsToAlertResponseOK>(options: AddDetailsToAlertRequest): Promise<AddDetailsToAlertResponseOK | T>;
    /**
     * Remove details of the alert with given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#remove-details-custom-properties-from-alert
     * @param options Request options.
     */
    removeDetails<T = RemoveDetailsFromAlertResponseOK>(options: RemoveDetailsFromAlertRequest): Promise<RemoveDetailsFromAlertResponseOK | T>;
}
declare class AlertSavedGroup {
    private implementation;
    private getGlobalErrorStrategy;
    Search: AlertSavedSearchGroup;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
}
declare class AlertSavedSearchGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Create saved search with given fields
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#create-a-saved-search
     * @param options Request options.
     */
    createSavedSearch<T = CreateSavedSearchForAlertResponseOK>(options: CreateSavedSearchForAlertRequest): Promise<CreateSavedSearchForAlertResponseOK | T>;
    /**
     * List all saved searches
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-saved-searches
     * @param options Request options.
     */
    getSavedSearches<T = GetSavedSearchesForAlertResponseOK>(options?: GetSavedSearchesForAlertRequest): Promise<GetSavedSearchesForAlertResponseOK | T>;
    /**
     * Update saved search for the given search identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#update-saved-search
     * @param options Request options.
     */
    updateSavedSearch<T = UpdateSavedSearchForAlertResponseOK>(options: UpdateSavedSearchForAlertRequest): Promise<UpdateSavedSearchForAlertResponseOK | T>;
    /**
     * Get saved search for the given search identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#get-saved-search
     * @param options Request options.
     */
    getSavedSearch<T = GetSavedSearchForAlertResponseOK>(options: GetSavedSearchForAlertRequest): Promise<GetSavedSearchForAlertResponseOK | T>;
    /**
     * Deletes saved search using given search identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#delete-saved-search
     * @param options Request options.
     */
    deleteSavedSearch<T = DeleteSavedSearchForAlertResponseOK>(options: DeleteSavedSearchForAlertRequest): Promise<DeleteSavedSearchForAlertResponseOK | T>;
}
declare class AlertAttachmentGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * List alert attachment names and urls for related alert
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#list-alert-attachments
     * @param options Request options.
     */
    getAttachments<T = GetAlertAttachmentsResponseOK>(options: GetAlertAttachmentsRequest): Promise<GetAlertAttachmentsResponseOK | T>;
    /**
     * Add Alert Attachment to related alert
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#create-alert-attachment
     * @param options Request options.
     */
    createAttachment<T = CreateAlertAttachmentResponseOK>(options: CreateAlertAttachmentRequest): Promise<CreateAlertAttachmentResponseOK | T>;
    /**
     * Get alert attachment name and url for the given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#get-alert-attachment
     * @param options Request options.
     */
    getAttachment<T = GetAlertAttachmentResponseOK>(options: GetAlertAttachmentRequest): Promise<GetAlertAttachmentResponseOK | T>;
    /**
     * Remove alert attachment for the given identifier
     * Documentation: https://docs.opsgenie.com/docs/alert-api-continued#delete-alert-attachment
     * @param options Request options.
     */
    deleteAttachment<T = DeleteAlertAttachmentResponseOK>(options: DeleteAlertAttachmentRequest): Promise<DeleteAlertAttachmentResponseOK | T>;
}
declare class IncidentGroup {
    private implementation;
    private getGlobalErrorStrategy;
    Alert: IncidentAlertGroup;
    Note: IncidentNoteGroup;
    Tags: IncidentTagsGroup;
    Details: IncidentDetailsGroup;
    Timeline: IncidentTimelineGroup;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Used to track the status and incident details (if any) of the request whose identifier is given
     * Documentation: https://docs.opsgenie.com/docs/incident-api#get-request-status
     * @param options Request options.
     */
    getRequestStatus<T = GetRequestStatusForIncidentResponseOK>(options: GetRequestStatusForIncidentRequest): Promise<GetRequestStatusForIncidentResponseOK | T>;
    /**
     * Creates a new incident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#create-incident
     * @param options Request options.
     */
    createIncident<T = CreateIncidentResponseOK>(options: CreateIncidentRequest): Promise<CreateIncidentResponseOK | T>;
    /**
     * Deletes an incident using incident id or the tiny id
     * Documentation: https://docs.opsgenie.com/docs/incident-api#delete-incident
     * @param options Request options.
     */
    deleteIncident<T = DeleteIncidentResponseOK>(options: DeleteIncidentRequest): Promise<DeleteIncidentResponseOK | T>;
    /**
     * Returns incident with given id, tiny id or alias
     * Documentation: https://docs.opsgenie.com/docs/incident-api#get-incident
     * @param options Request options.
     */
    getIncident<T = GetIncidentResponseOK>(options: GetIncidentRequest): Promise<GetIncidentResponseOK | T>;
    /**
     * Return list of incidents
     * Documentation: https://docs.opsgenie.com/docs/incident-api#list-incidents
     * @param options Request options.
     */
    getIncidents<T = GetIncidentsResponseOK>(options?: GetIncidentsRequest): Promise<GetIncidentsResponseOK | T>;
    /**
     * Closes incident with given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#close-incident
     * @param options Request options.
     */
    closeIncident<T = CloseIncidentResponseOK>(options: CloseIncidentRequest): Promise<CloseIncidentResponseOK | T>;
    /**
     * Resolves incident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#resolve-incident
     * @param options Request options.
     */
    resolveIncident<T = ResolveIncidentResponseOK>(options: ResolveIncidentRequest): Promise<ResolveIncidentResponseOK | T>;
    /**
     * Reopenss incident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#reopen-incident
     * @param options Request options.
     */
    reopenIncident<T = ReopenIncidentResponseOK>(options: ReopenIncidentRequest): Promise<ReopenIncidentResponseOK | T>;
    /**
     * Add responder to incident with given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#add-responder-to-incident
     * @param options Request options.
     */
    addResponder<T = AddResponderToIncidentResponseOK>(options: AddResponderToIncidentRequest): Promise<AddResponderToIncidentResponseOK | T>;
    /**
     * Update the priority of the incident with given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#update-incident-priority
     * @param options Request options.
     */
    updatePriority<T = UpdateIncidentPriorityResponseOK>(options: UpdateIncidentPriorityRequest): Promise<UpdateIncidentPriorityResponseOK | T>;
    /**
     * Update the Message of the incident with given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#update-incident-message
     * @param options Request options.
     */
    updateMessage<T = UpdateIncidentMessageResponseOK>(options: UpdateIncidentMessageRequest): Promise<UpdateIncidentMessageResponseOK | T>;
    /**
     * Update the Description of the incident with given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#update-incident-description
     * @param options Request options.
     */
    updateDescription<T = UpdateIncidentDescriptionResponseOK>(options: UpdateIncidentDescriptionRequest): Promise<UpdateIncidentDescriptionResponseOK | T>;
    /**
     * List incident logs for the given incident identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#list-incident-logs
     * @param options Request options.
     */
    getLogs<T = GetIncidentLogsResponseOK>(options: GetIncidentLogsRequest): Promise<GetIncidentLogsResponseOK | T>;
}
declare class IncidentAlertGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Returns associated alerts for incident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#get-associated-alerts
     * @param options Request options.
     */
    getAssociatedAlerts<T = GetAssociatedAlertsForIncidentResponseOK>(options: GetAssociatedAlertsForIncidentRequest): Promise<GetAssociatedAlertsForIncidentResponseOK | T>;
    /**
     * Returns responder alerts for incident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#get-responder-alerts
     * @param options Request options.
     */
    getResponderAlerts<T = GetResponderAlertsForIncidentResponseOK>(options: GetResponderAlertsForIncidentRequest): Promise<GetResponderAlertsForIncidentResponseOK | T>;
}
declare class IncidentNoteGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Adds note to incident with given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#add-note-to-incident
     * @param options Request options.
     */
    addNote<T = AddNoteToIncidentResponseOK>(options: AddNoteToIncidentRequest): Promise<AddNoteToIncidentResponseOK | T>;
    /**
     * List incident notes for the given alert identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#list-incident-notes
     * @param options Request options.
     */
    getNotes<T = GetIncidentNotesResponseOK>(options: GetIncidentNotesRequest): Promise<GetIncidentNotesResponseOK | T>;
}
declare class IncidentTagsGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Add tags to incident with given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#add-tags-to-incident
     * @param options Request options.
     */
    addTags<T = AddTagsToIncidentResponseOK>(options: AddTagsToIncidentRequest): Promise<AddTagsToIncidentResponseOK | T>;
    /**
     * Remove tags from incident with given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-api#remove-tags-from-incident
     * @param options Request options.
     */
    removeTags<T = RemoveTagsFromIncidentResponseOK>(options: RemoveTagsFromIncidentRequest): Promise<RemoveTagsFromIncidentResponseOK | T>;
}
declare class IncidentDetailsGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Add Details(Custom Properties) to Incident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#add-detailscustom-properties-to-incident
     * @param options Request options.
     */
    addDetails<T = AddDetailsToIncidentResponseOK>(options: AddDetailsToIncidentRequest): Promise<AddDetailsToIncidentResponseOK | T>;
    /**
     * Remove details from Incident
     * Documentation: https://docs.opsgenie.com/docs/incident-api#remove-detailscustom-properties-from-incident
     * @param options Request options.
     */
    removeDetails<T = RemoveDetailsFromIncidentResponseOK>(options: RemoveDetailsFromIncidentRequest): Promise<RemoveDetailsFromIncidentResponseOK | T>;
}
declare class IncidentTimelineGroup {
    private implementation;
    private getGlobalErrorStrategy;
    constructor(implementation: PlatformImplementation, getGlobalErrorStrategy: GetGlobalErrorStrategy);
    /**
     * Add Incident Timeline Entry to incident with the incident Id
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#add-incident-timeline-entry
     * @param options Request options.
     */
    addEntry<T = AddIncidentTimelineEntryResponseOK>(options: AddIncidentTimelineEntryRequest): Promise<AddIncidentTimelineEntryResponseOK | T>;
    /**
     * List incident timeline entries for the given incident Id
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#list-incident-timeline-entries
     * @param options Request options.
     */
    getEntries<T = GetIncidentTimelineEntriesResponseOK>(options: GetIncidentTimelineEntriesRequest): Promise<GetIncidentTimelineEntriesResponseOK | T>;
    /**
     * Get incident timeline entry for the given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#get-incident-timeline-entry
     * @param options Request options.
     */
    getEntry<T = GetIncidentTimelineEntryResponseOK>(options: GetIncidentTimelineEntryRequest): Promise<GetIncidentTimelineEntryResponseOK | T>;
    /**
     * Updates incident timeline entry for the given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#update-incident-timeline-entry
     * @param options Request options.
     */
    updateEntry<T = UpdateIncidentTimelineEntryResponseOK>(options: UpdateIncidentTimelineEntryRequest): Promise<UpdateIncidentTimelineEntryResponseOK | T>;
    /**
     * Deletes incident timeline entry for the given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#delete-incident-timeline-entry
     * @param options Request options.
     */
    deleteEntry<T = DeleteIncidentTimelineEntryResponseOK>(options: DeleteIncidentTimelineEntryRequest): Promise<DeleteIncidentTimelineEntryResponseOK | T>;
    /**
     * Hides incident timeline entry for the given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#hide-incident-timeline-entry
     * @param options Request options.
     */
    hideEntry<T = HideIncidentTimelineEntryResponseOK>(options: HideIncidentTimelineEntryRequest): Promise<HideIncidentTimelineEntryResponseOK | T>;
    /**
     * Unhides incident timeline entry for the given identifier
     * Documentation: https://docs.opsgenie.com/docs/incident-timeline-api#unhide-incident-timeline-entry
     * @param options Request options.
     */
    unhideEntry<T = UnhideIncidentTimelineEntryResponseOK>(options: UnhideIncidentTimelineEntryRequest): Promise<UnhideIncidentTimelineEntryResponseOK | T>;
}
export {};
//# sourceMappingURL=index.d.ts.map