/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { AddDetailsToAlertPayload } from "../../definitions/AddDetailsToAlertPayload";
import { SuccessResponseAsResponse } from "../../definitions/SuccessResponseAsResponse";
import { ErrorResponseAsResponse } from "../../definitions/ErrorResponseAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface AddDetailsToAlertRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of alert which could be alert id, tiny id or alert alias
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
     */
    identifierType?: "id" | "alias" | "tiny";
    body: AddDetailsToAlertPayload;
}
declare type AddDetailsToAlertResponseOKType = SuccessResponseAsResponse;
export interface AddDetailsToAlertResponseOK extends AddDetailsToAlertResponseOKType {
}
declare type AddDetailsToAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface AddDetailsToAlertResponseError extends AddDetailsToAlertResponseErrorType {
}
export interface RemoveDetailsFromAlertRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of alert which could be alert id, tiny id or alert alias
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
     */
    identifierType?: "id" | "alias" | "tiny";
    /**
     * Display name of the request owner
     */
    user?: string;
    /**
     * Additional alert note to add
     */
    note?: string;
    /**
     * Display name of the request source
     */
    source?: string;
    /**
     * Comma separated list of keys to remove from the custom properties of the alert (e.g. 'key1,key2')
     */
    keys: Array<string>;
}
declare type RemoveDetailsFromAlertResponseOKType = SuccessResponseAsResponse;
export interface RemoveDetailsFromAlertResponseOK extends RemoveDetailsFromAlertResponseOKType {
}
declare type RemoveDetailsFromAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface RemoveDetailsFromAlertResponseError extends RemoveDetailsFromAlertResponseErrorType {
}
export {};
//# sourceMappingURL=details.d.ts.map