/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { AddNoteToAlertPayload } from "../../definitions/AddNoteToAlertPayload";
import { SuccessResponseAsResponse } from "../../definitions/SuccessResponseAsResponse";
import { ErrorResponseAsResponse } from "../../definitions/ErrorResponseAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { ListAlertNotesResponseAsResponse } from "../../definitions/ListAlertNotesResponseAsResponse";
export interface AddNoteToAlertRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of alert which could be alert id, tiny id or alert alias
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
     */
    identifierType?: "id" | "alias" | "tiny";
    body: AddNoteToAlertPayload;
}
declare type AddNoteToAlertResponseOKType = SuccessResponseAsResponse;
export interface AddNoteToAlertResponseOK extends AddNoteToAlertResponseOKType {
}
declare type AddNoteToAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface AddNoteToAlertResponseError extends AddNoteToAlertResponseErrorType {
}
export interface GetAlertNotesRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of alert which could be alert id, tiny id or alert alias
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
     */
    identifierType?: "id" | "alias" | "tiny";
    /**
     * Starting value of the offset property
     */
    offset?: string;
    /**
     * Page direction to apply for the given offset with 'next' and 'prev'
     */
    direction?: "next" | "prev";
    /**
     * Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 100
     */
    limit?: number;
    /**
     * Sorting order of the result set
     */
    order?: "asc" | "desc";
}
declare type GetAlertNotesResponseOKType = ListAlertNotesResponseAsResponse;
export interface GetAlertNotesResponseOK extends GetAlertNotesResponseOKType {
}
declare type GetAlertNotesResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface GetAlertNotesResponseError extends GetAlertNotesResponseErrorType {
}
export {};
//# sourceMappingURL=note.d.ts.map