/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { CreateSavedSearchPayload } from "../../../definitions/CreateSavedSearchPayload";
import { CreateSavedSearchResponseAsResponse } from "../../../definitions/CreateSavedSearchResponseAsResponse";
import { ErrorResponseAsResponse } from "../../../definitions/ErrorResponseAsResponse";
import { ErrorStrategyOption } from "../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { ListSavedSearchesResponseAsResponse } from "../../../definitions/ListSavedSearchesResponseAsResponse";
import { UpdateSavedSearchPayload } from "../../../definitions/UpdateSavedSearchPayload";
import { BaseResponseAsResponse } from "../../../definitions/BaseResponseAsResponse";
import { SavedSearchMetaAsResponse } from "../../../definitions/SavedSearchMetaAsResponse";
import { GetSavedSearchResponseAsResponse } from "../../../definitions/GetSavedSearchResponseAsResponse";
import { SuccessResponseAsResponse } from "../../../definitions/SuccessResponseAsResponse";
export interface CreateSavedSearchForAlertRequest extends HeadersOption, ErrorStrategyOption {
    body: CreateSavedSearchPayload;
}
declare type CreateSavedSearchForAlertResponseOKType = CreateSavedSearchResponseAsResponse;
export interface CreateSavedSearchForAlertResponseOK extends CreateSavedSearchForAlertResponseOKType {
}
declare type CreateSavedSearchForAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface CreateSavedSearchForAlertResponseError extends CreateSavedSearchForAlertResponseErrorType {
}
export interface GetSavedSearchesForAlertRequest extends HeadersOption, ErrorStrategyOption {
}
declare type GetSavedSearchesForAlertResponseOKType = ListSavedSearchesResponseAsResponse;
export interface GetSavedSearchesForAlertResponseOK extends GetSavedSearchesForAlertResponseOKType {
}
declare type GetSavedSearchesForAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface GetSavedSearchesForAlertResponseError extends GetSavedSearchesForAlertResponseErrorType {
}
export interface UpdateSavedSearchForAlertRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of the saved search which could be 'id' or 'name'
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
     */
    identifierType?: "id" | "name";
    body: UpdateSavedSearchPayload;
}
export declare type UpdateSavedSearchForAlertResponseOK = BaseResponseAsResponse & {
    data?: SavedSearchMetaAsResponse;
};
declare type UpdateSavedSearchForAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface UpdateSavedSearchForAlertResponseError extends UpdateSavedSearchForAlertResponseErrorType {
}
export interface GetSavedSearchForAlertRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of the saved search which could be 'id' or 'name'
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
     */
    identifierType?: "id" | "name";
}
declare type GetSavedSearchForAlertResponseOKType = GetSavedSearchResponseAsResponse;
export interface GetSavedSearchForAlertResponseOK extends GetSavedSearchForAlertResponseOKType {
}
declare type GetSavedSearchForAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface GetSavedSearchForAlertResponseError extends GetSavedSearchForAlertResponseErrorType {
}
export interface DeleteSavedSearchForAlertRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of the saved search which could be 'id' or 'name'
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', or 'name'
     */
    identifierType?: "id" | "name";
}
declare type DeleteSavedSearchForAlertResponseOKType = SuccessResponseAsResponse;
export interface DeleteSavedSearchForAlertResponseOK extends DeleteSavedSearchForAlertResponseOKType {
}
declare type DeleteSavedSearchForAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface DeleteSavedSearchForAlertResponseError extends DeleteSavedSearchForAlertResponseErrorType {
}
export {};
//# sourceMappingURL=search.d.ts.map