/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { AddTagsToAlertPayload } from "../../definitions/AddTagsToAlertPayload";
import { SuccessResponseAsResponse } from "../../definitions/SuccessResponseAsResponse";
import { ErrorResponseAsResponse } from "../../definitions/ErrorResponseAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface AddTagsToAlertRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of alert which could be alert id, tiny id or alert alias
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
     */
    identifierType?: "id" | "alias" | "tiny";
    body: AddTagsToAlertPayload;
}
declare type AddTagsToAlertResponseOKType = SuccessResponseAsResponse;
export interface AddTagsToAlertResponseOK extends AddTagsToAlertResponseOKType {
}
declare type AddTagsToAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface AddTagsToAlertResponseError extends AddTagsToAlertResponseErrorType {
}
export interface RemoveTagsFromAlertRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of alert which could be alert id, tiny id or alert alias
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id', 'alias' or 'tiny'
     */
    identifierType?: "id" | "alias" | "tiny";
    /**
     * Display name of the request owner
     */
    user?: string;
    /**
     * Additional alert note to add
     */
    note?: string;
    /**
     * Display name of the request source
     */
    source?: string;
    /**
     * Tags field of the given alert as comma seperated values (e.g. 'tag1, tag2')
     */
    tags: Array<string>;
}
declare type RemoveTagsFromAlertResponseOKType = SuccessResponseAsResponse;
export interface RemoveTagsFromAlertResponseOK extends RemoveTagsFromAlertResponseOKType {
}
declare type RemoveTagsFromAlertResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface RemoveTagsFromAlertResponseError extends RemoveTagsFromAlertResponseErrorType {
}
export {};
//# sourceMappingURL=tags.d.ts.map