/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { BaseResponseAsResponse } from "../../definitions/BaseResponseAsResponse";
import { PageDetailsAsResponse } from "../../definitions/PageDetailsAsResponse";
import { ErrorResponseAsResponse } from "../../definitions/ErrorResponseAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface GetAssociatedAlertsForIncidentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of incident which could be incident id or tiny id
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id' or 'tiny. Default is id'
     */
    identifierType?: "id" | "tiny";
    /**
     * Sorting order of the result set
     */
    order?: "asc" | "desc";
    /**
     * Starting value of the offset property
     */
    offset?: string;
    /**
     * Page direction to apply for the given offset with 'next' and 'prev'
     */
    direction?: "next" | "prev";
    /**
     * Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 25
     */
    limit?: number;
}
export declare type GetAssociatedAlertsForIncidentResponseOK = BaseResponseAsResponse & {
    data?: Array<string>;
    paging?: PageDetailsAsResponse;
};
declare type GetAssociatedAlertsForIncidentResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface GetAssociatedAlertsForIncidentResponseError extends GetAssociatedAlertsForIncidentResponseErrorType {
}
export interface GetResponderAlertsForIncidentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of incident which could be incident id or tiny id
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id' or 'tiny. Default is id'
     */
    identifierType?: "id" | "tiny";
    /**
     * Sorting order of the result set
     */
    order?: "asc" | "desc";
    /**
     * Starting value of the offset property
     */
    offset?: string;
    /**
     * Page direction to apply for the given offset with 'next' and 'prev'
     */
    direction?: "next" | "prev";
    /**
     * Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 25
     */
    limit?: number;
}
export declare type GetResponderAlertsForIncidentResponseOK = BaseResponseAsResponse & {
    data?: Array<string>;
    paging?: PageDetailsAsResponse;
};
declare type GetResponderAlertsForIncidentResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface GetResponderAlertsForIncidentResponseError extends GetResponderAlertsForIncidentResponseErrorType {
}
export {};
//# sourceMappingURL=alert.d.ts.map