/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { SuccessResponseAsResponse } from "../../definitions/SuccessResponseAsResponse";
import { ErrorResponseAsResponse } from "../../definitions/ErrorResponseAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface AddDetailsToIncidentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of incident which could be incident id or tiny id
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id' or 'tiny. Default is id'
     */
    identifierType?: "id" | "tiny";
    body: {
        /**
         * Additional incident note to add.
         */
        note?: string;
        /**
         * Key-value pairs to add as custom property into incident.
         */
        details: {
            [x: string]: string;
        };
    };
}
declare type AddDetailsToIncidentResponseOKType = SuccessResponseAsResponse;
export interface AddDetailsToIncidentResponseOK extends AddDetailsToIncidentResponseOKType {
}
declare type AddDetailsToIncidentResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface AddDetailsToIncidentResponseError extends AddDetailsToIncidentResponseErrorType {
}
export interface RemoveDetailsFromIncidentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of incident which could be incident id or tiny id
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id' or 'tiny. Default is id'
     */
    identifierType?: "id" | "tiny";
    /**
     * Additional incident note to add.
     */
    note?: string;
    /**
     * Comma separated list of keys to remove from the custom properties of the incident.
     */
    keys: Array<string>;
}
declare type RemoveDetailsFromIncidentResponseOKType = SuccessResponseAsResponse;
export interface RemoveDetailsFromIncidentResponseOK extends RemoveDetailsFromIncidentResponseOKType {
}
declare type RemoveDetailsFromIncidentResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface RemoveDetailsFromIncidentResponseError extends RemoveDetailsFromIncidentResponseErrorType {
}
export {};
//# sourceMappingURL=details.d.ts.map