/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { SuccessResponseAsResponse } from "../../definitions/SuccessResponseAsResponse";
import { ErrorResponseAsResponse } from "../../definitions/ErrorResponseAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { BaseResponseAsResponse } from "../../definitions/BaseResponseAsResponse";
import { PageDetailsAsResponse } from "../../definitions/PageDetailsAsResponse";
export interface AddNoteToIncidentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of incident which could be incident id or tiny id
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id' or 'tiny. Default is id'
     */
    identifierType?: "id" | "tiny";
    body: {
        /**
         * Incident note to add
         */
        note: string;
    };
}
declare type AddNoteToIncidentResponseOKType = SuccessResponseAsResponse;
export interface AddNoteToIncidentResponseOK extends AddNoteToIncidentResponseOKType {
}
declare type AddNoteToIncidentResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface AddNoteToIncidentResponseError extends AddNoteToIncidentResponseErrorType {
}
export interface GetIncidentNotesRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of incident which could be incident id or tiny id
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id' or 'tiny. Default is id'
     */
    identifierType?: "id" | "tiny";
    /**
     * Sorting order of the result set
     */
    order?: "asc" | "desc";
    /**
     * Starting value of the offset property
     */
    offset?: string;
    /**
     * Page direction to apply for the given offset with 'next' and 'prev'
     */
    direction?: "next" | "prev";
    /**
     * Maximum number of items to provide in the result. Must be a positive integer value. Default value is 20 and maximum value is 100
     */
    limit?: number;
}
export declare type GetIncidentNotesResponseOK = BaseResponseAsResponse & {
    data?: Array<{
        note?: string;
        owner?: string;
        createdAt?: string;
        offset?: string;
    }>;
    paging?: PageDetailsAsResponse;
};
declare type GetIncidentNotesResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface GetIncidentNotesResponseError extends GetIncidentNotesResponseErrorType {
}
export {};
//# sourceMappingURL=note.d.ts.map