/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { SuccessResponseAsResponse } from "../../definitions/SuccessResponseAsResponse";
import { ErrorResponseAsResponse } from "../../definitions/ErrorResponseAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface AddTagsToIncidentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of incident which could be incident id or tiny id
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id' or 'tiny. Default is id'
     */
    identifierType?: "id" | "tiny";
    body: {
        /**
         * Additional incident note to add.
         */
        note?: string;
        /**
         * List of tags to add into incident.
         */
        tags: Array<string>;
    };
}
declare type AddTagsToIncidentResponseOKType = SuccessResponseAsResponse;
export interface AddTagsToIncidentResponseOK extends AddTagsToIncidentResponseOKType {
}
declare type AddTagsToIncidentResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface AddTagsToIncidentResponseError extends AddTagsToIncidentResponseErrorType {
}
export interface RemoveTagsFromIncidentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Identifier of incident which could be incident id or tiny id
     */
    identifier: string;
    /**
     * Type of the identifier that is provided as an in-line parameter. Possible values are 'id' or 'tiny. Default is id'
     */
    identifierType?: "id" | "tiny";
    /**
     * Additional incident note to add.
     */
    note?: string;
    /**
     * Comma separated list of tags to remove from incident.
     */
    tags: Array<string>;
}
declare type RemoveTagsFromIncidentResponseOKType = SuccessResponseAsResponse;
export interface RemoveTagsFromIncidentResponseOK extends RemoveTagsFromIncidentResponseOKType {
}
declare type RemoveTagsFromIncidentResponseErrorType = ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse & ErrorResponseAsResponse;
export interface RemoveTagsFromIncidentResponseError extends RemoveTagsFromIncidentResponseErrorType {
}
export {};
//# sourceMappingURL=tags.d.ts.map